﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;

namespace TreeViewAddChildSelfReferencing
{
	public class DataItem : ViewModelBase
	{
		public DataItem()
		{
			Children = new ObservableCollection<DataItem>();
		}


		private bool isSelected;
		public bool IsSelected
		{
			get
			{
				return this.isSelected;
			}
			set
			{
				if (this.isSelected != value)
				{
					this.isSelected = value;
					OnPropertyChanged("IsSelected");
				}
			}
		}


		private bool isExpanded;
		public bool IsExpanded
		{
			get
			{
				return this.isExpanded;
			}
			set
			{
				if (this.isExpanded != value)
				{
					this.isExpanded = value;
					OnPropertyChanged("IsExpanded");
				}
			}
		}


		public int Id
		{
			get;
			set;
		}
		public int ParentId
		{
			get;
			set;
		}
		public string Text
		{
			get;
			set;
		}
		public DataItemCollection Owner
		{
			get;
			protected set;
		}
		internal void SetOwner(DataItemCollection collection)
		{
			this.Owner = collection;
		}
		internal void SetChildren(ObservableCollection<DataItem> collection)
		{
			this.Children = collection;
		}

		public ObservableCollection<DataItem> Children
		{
			get;
			set;
		}
	}
}
