﻿using System;
using System.Net;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;

namespace TreeViewAddChildSelfReferencing
{
	public class DataItemCollection : ObservableCollection<DataItem>
	{
		public DataItemCollection()
		{
			Add(new DataItem() { Text = "Item 1", Id = 1, ParentId = 0 });
			Add(new DataItem() { Text = "Item 2", Id = 2, ParentId = 0 });
			Add(new DataItem() { Text = "Item 3", Id = 3, ParentId = 0 });
			Add(new DataItem() { Text = "Item 1.1", Id = 4, ParentId = 1 });
			Add(new DataItem() { Text = "Item 1.2", Id = 5, ParentId = 1 });
			Add(new DataItem() { Text = "Item 1.3", Id = 6, ParentId = 1 });
			Add(new DataItem() { Text = "Item 2.1", Id = 7, ParentId = 2 });
			Add(new DataItem() { Text = "Item 2.2", Id = 8, ParentId = 2 });
			Add(new DataItem() { Text = "Item 2.3", Id = 9, ParentId = 2 });
			Add(new DataItem() { Text = "Item 3.1", Id = 10, ParentId = 3 });
			Add(new DataItem() { Text = "Item 3.2", Id = 11, ParentId = 3 });
			Add(new DataItem() { Text = "Item 3.3", Id = 12, ParentId = 3 });

			RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); });
			AddCommand = new DelegateCommand((p) => { this.AddItem(p); });
		}

		public DelegateCommand AddCommand { get; set; }

		public DelegateCommand RemoveCommand { get; set; }

		public void RemoveItem(object param)
		{
			DataItem item = param as DataItem;
			if (item.ParentId == 0)
				this.Remove(item);
			else
			{
				this.Where(i => i.Id == item.ParentId).FirstOrDefault().Children.Remove(item);
			}

		}

		public void AddItem(object param)
		{
			(param as DataItem).Children.Add(new DataItem()
			{
				Text = "NewItem",
				ParentId = (param as DataItem).Id,
				Id = 111,
				IsSelected = true
			});
			(param as DataItem).IsExpanded = true;
		}

		protected override void InsertItem(int index, DataItem item)
		{
			this.AdoptItem(item);
			base.InsertItem(index, item);
		}
		protected override void RemoveItem(int index)
		{
			this.DiscardItem(this[index]);
			base.RemoveItem(index);
		}
		protected override void SetItem(int index, DataItem item)
		{
			this.AdoptItem(item);
			base.SetItem(index, item);
		}
		protected override void ClearItems()
		{
			foreach (DataItem item in this)
			{
				this.DiscardItem(item);
			}
			base.ClearItems();
		}
		private void AdoptItem(DataItem item)
		{
			item.SetOwner(this);
		}
		private void DiscardItem(DataItem item)
		{
			item.SetOwner(null);
			item.SetChildren(null);
		}
	}
}
